/*
 File: rtn_componentsym.cpp
 Date and Time: Fri Jan 30 18:55:22 2015 
*/
#include "rtn_component.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rtn_component;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_rtn_component::TH_rtn_component(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_rtn_component;
  NS_rtn_component::Crtn_component Crtn_component_;// parallel-parser's parse table
#define ssPARSE_TABLE Crtn_component_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_rtn_component::PROC_TH_rtn_component(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_rtn_component";
  static bool one_time(false);
  static NS_rtn_component::Crtn_component* NS_rtn_component_Crtn_component_(0);// parallel-parser's fsm table
  static Parser* NS_rtn_component_Crtn_component_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_rtn_component_Crtn_component_ = new NS_rtn_component::Crtn_component();// parallel-parser's fsm table
    NS_rtn_component_Crtn_component_parser = new Parser(*NS_rtn_component_Crtn_component_,Caller_pp);
  }
 proc_parser = NS_rtn_component_Crtn_component_parser;
#include "wproc_pp_core.h"
}
void 
Crtn_component::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     return;}
    case rhs6_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr6();
     return;}
    case rhs7_Rrtn_component_:{
       Rrtn_component* sym;
     if(re->rule_ == 0){
       sym = new Rrtn_component(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtn_component*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     return;}
    default: return;
   }
}
